#include <Wire.h>   
#include <Psx.h>

#define PCF8574     0x40 >> 1
#define PCF8574A    0x70 >> 1

int out[8]={0x00,0x01,0x02,0x04,0x08,0x10,0x20,0x40};

int dataPin=2;
int cmdPin=3;
int attPin=4;
int clockPin=5;

Psx Psx;

unsigned int data = 0;

void setup()
{
  Wire.begin();
  Psx.setupPins(dataPin, cmdPin, attPin, clockPin, 10000);
  Serial.begin(9600);
  Serial.print("PSX Joy Stick Control");
  Serial.println();
}

void loop()
{

  data = Psx.read();
  
  if(data & psxLeft){
    Serial.println("Left");
    WriteOutput(PCF8574,~out[3]);
    delay(100);
  }
  else if(data & psxRight){
    Serial.println("Right");
    WriteOutput(PCF8574,~out[4]);
    delay(100);
  }
  else if(data & psxUp){
    Serial.println("Up");
    WriteOutput(PCF8574,~out[1]);
    delay(100);
  }
  else if(data & psxDown){
    Serial.println("Down");
    WriteOutput(PCF8574,~out[2]);
    delay(100);
  }
  else if(data & psxStrt){
    Serial.println("Start");
    WriteOutput(PCF8574A,~out[7]);
    delay(100);
  }
  else if(data & psxSlct){
    Serial.println("Selete");
    WriteOutput(PCF8574,~out[7]);
    delay(100);
  }
  else if(data & psxX){
    Serial.println("X");
    WriteOutput(PCF8574A,~out[2]);
    delay(100);
  }
  else if(data & psxO){
    Serial.println("O");
    WriteOutput(PCF8574A,~out[4]);
    delay(100);
  }
  else if(data & psxTri){
    Serial.println("Tri");
    WriteOutput(PCF8574A,~out[1]);
    delay(100);
  }
  else if(data & psxSqu){
    Serial.println("Squear");
    WriteOutput(PCF8574A,~out[3]);
    delay(100);
  }
  else if(data & psxR1){
    Serial.println("R1");
    WriteOutput(PCF8574A,~out[5]);
    delay(100);
  }
  else if(data & psxR2){
    Serial.println("R2");
    WriteOutput(PCF8574A,~out[6]);
    delay(100);
  }
  else if(data & psxL1){
    Serial.println("L1");
    WriteOutput(PCF8574,~out[5]);
    delay(100);
  }
  else if(data & psxL2){
    Serial.println("L2");
    WriteOutput(PCF8574,~out[6]);
    delay(100);
  }
  else
  {
    WriteOutput(PCF8574,~out[0]);
    delay(100);
    WriteOutput(PCF8574A,~out[0]);
    delay(100);
  }  
}

void WriteOutput(int IDCode, byte Output)             
{
  Wire.beginTransmission(IDCode);                    
  Wire.send(Output);                                  
  Wire.endTransmission();                             
}
